@()
<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>OB User Microservice</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">

  </head>

  <body ng-app="ngAppDemo">

    <nav class="navbar navbar-default">
      <div class="container-fluid">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="#">OB User MicroService</a>
        </div>
        <form class="navbar-form navbar-right">
          <div class="form-group">
            <input type="text" class="form-control" placeholder="Filter Results" ng-model="searchText">
          </div>
        </form>
        <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
          <ul class="nav navbar-nav navbar-right">
          </ul>
        </div><!-- /.navbar-collapse -->
      </div><!-- /.container-fluid -->
    </nav>

    <div class="col-md-12" ng-controller="mainCtrl">
      <div class="alert alert-warning" ng-show="responseChange" ng-cloak>{{responseMessage}}</div>
      <div class="container">
        <div class="table-responsive">
          <table class="table">
            <thead>
              <tr>
                <th>First Name</th>
                <th>Last Name</th>
                <th>Email</th>
                <th>Actions</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <form name="form">
                  <td><input type="text" class="form-control" ng-model="newUser.firstName" placeholder="First Name" required></td>
                  <td><input type="text" class="form-control" ng-model="newUser.lastName" placeholder="Last Name" required></td>
                  <td><input type="email" name="email" class="form-control" ng-model="newUser.email"  placeholder="E-Mail" required></td>
                  <td><button type="submit" ng-disabled="form.$invalid" class="btn btn-success" ng-click="checkBeforeAdd(newUser)">Add</button></td>
                </form>
              </tr>

              <tr ng-repeat="u in allUsers | filter:searchText">
                <td>{{u.firstName}}</td>
                <td>{{u.lastName}}</td>
                <td>{{u.email}}</td>
                <td><button class="btn btn-primary" ng-click="edit(u)">See More</button></td>
              </tr>
            </tbody>
        </table>
      </div>
    </div>

    </div>


    <script src="http://code.angularjs.org/snapshot/angular.min.js"></script>
    <script>
      (function(angular) {
        'use strict';
      angular.module('ngAppDemo', []).controller('mainCtrl', function($scope, $http, $timeout) {

        function showMessage(message){
          $scope.responseMessage = message;
          $scope.responseChange = true;
          $timeout(function () {
            $scope.responseChange = false;
          }, 3500);
        }


        //gets data from user endpoint
        $scope.loadAll = function(){
          $http({
            method: 'GET',
            url: '/users'
          }).then(function successCallback(response) {
              $scope.allUsers = response.data;
              //success
            }, function errorCallback(response) {
              showMessage("Data update failed");
              //error
            });
          }
          $scope.loadAll();

          $scope.newUser = {};

          $scope.checkBeforeAdd = function(user){

            $http({
              method: 'GET',
              url: '/users/?email='+user.email
            }).then(function successCallback(response) {
              if(response.data.length>0){
                showMessage("User with this Email already Exists");
              }else{
                $scope.addUser(user);
              }
              }, function errorCallback(response) {
                return response.data;
              });

          }


          //deletes a user based on email
          $scope.addUser = function(user){
              $http({
                method: 'POST',
                url: '/users/',
                data: user
              }).then(function successCallback(response) {
                  $scope.newUser = {};
                  showMessage(response.data);
                  $scope.loadAll();
                }, function errorCallback(response) {
                  showMessage(response.data);
                });
          }

          $scope.findByEmail = function(email){

            $http({
              method: 'GET',
              url: '/users/?email='+email
            }).then(function successCallback(response) {
                showMessage(response.data);
                $scope.loadAll();
                $scope.foundEmails = response.data;
                return response.data;
              }, function errorCallback(response) {
                showMessage(response.data);
                return response.data;
              });
          }

          function findByEmail(emailString){
            $http({
              method: 'GET',
              url: '/users/?email='+emailString
            }).then(function successCallback(response) {
              console.log(response.data);
                return response.data;
              }, function errorCallback(response) {
                return response.data;
              });
          }


          $scope.edit = function(user){
            $http({
              method: 'GET',
              url: '/users/?email='+user.email
            }).then(function successCallback(response) {
                alert(JSON.stringify(response.data));
                // showMessage(response.data);
                $scope.loadAll();
              }, function errorCallback(response) {
                showMessage(response.data);
              });
          }

          function validate(user){
            console.log($scope.foundEmails);
            if($scope.foundEmails.length>0){
              return false;
            }else{
              return true;
            }
          };


      });
      })(window.angular);
    </script>

  </body>
</html>
